/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.etsi.saref.server.resources;

import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QueryFactory;
import org.apache.jena.query.ReadWrite;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdfconnection.RDFConnection;
import org.apache.jena.rdfconnection.RDFConnectionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Redirect:
 *
 * @author maxime.lefrancois
 */
@WebFilter(urlPatterns = {"/core*"})
public class CoreFilter implements Filter {

    static final String NS = "https://saref.etsi.org/";
    private static final String DS = "http://localhost:3030/ds/";
    private static final Logger LOG = LoggerFactory.getLogger(CoreFilter.class);
    private static final String CONFIG = "http://example.org/" + "config";

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
        LOG.info("starting...");
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
//        HttpServletRequest req = ((HttpServletRequest) request);
//        String contextPath = req.getContextPath() + "/";
//        String requestURI = req.getRequestURI();
//        String resourcePath = requestURI.substring(contextPath.length());
//        System.out.println("ResourcePath is " + resourcePath);
//        String redirection = null;
//
//        if (resourcePath.equals("core")) {
//
//            // find latest version of core.
//            try (RDFConnection conn = RDFConnectionFactory.connect(DS)) {
//                try (QueryExecution exec = conn.query("PREFIX ex: <http://example.org/>\n"
//                        + "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>\n"
//                        + "SELECT ?v\n"
//                        + "FROM <http://example.org/config>\n"
//                        + "WHERE {\n"
//                        + "  \n"
//                        + "  <https://saref.etsi.org/core/> ex:hasVersion ?v .\n"
//                        + "  FILTER NOT EXISTS {\n"
//                        + "    ?v2 ex:priorVersion ?v .\n"
//                        + "  }\n"
//                        + "}")) {
//                    String uri = exec.execSelect().next().getResource("v").getURI();
//                    redirection = uri.substring(NS.length());
//
//                }
//            }
//        }
//
//        if (redirection != null) {
//            HttpServletResponse res = (HttpServletResponse) response;
//            res.setHeader("Location", redirection);
//            res.setStatus(HttpServletResponse.SC_SEE_OTHER);
//            res.flushBuffer();
//            return;
//        }
        chain.doFilter(request, response);
    }

    @Override
    public void destroy() {
    }
}
